/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/attribute.c
* Description:  Implements attribute.h
* Author:       Brett Kessler
* Created:      Sun Apr 26 21:24:59 1992
* Modified:     Sun May  3 16:42:16 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "attribute.h"
#include "Malloc.h"
#include "sign.h"
#include "terminal.h"

Attribute
Attribute_Create(Sign direction, int id)
{
  Attribute a;
  a = Malloc_Struct(attribute);
  a->direction = direction;
  a->id = id;
  return a;
}

/* Note that props is a bit mask, where each attribute is represented
 * by 2 raised to its attribute ID.
 */
Boolean
Attribute_Match(Attribute attribute, Terminal_Properties props)
{
  Terminal_Properties contains;
  contains = props & (1uL << attribute->id);
  return ((attribute->direction->u.direction == Sign_PLUS && contains) ||
	  (attribute->direction->u.direction == Sign_MINUS && !contains));
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
