/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/attributes.c
* Description:  Implements attributes.h
* Author:       Brett Kessler
* Created:      Sun Apr 26 21:30:59 1992
* Modified:     Sun May  3 16:42:15 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "attributes.h"
#include "Malloc.h"
#include <stdarg.h>

Attributes
Attributes_Create(int nAttributes, ...)
{
  int a;
  Attributes attributes;
  va_list args;
  va_start(args, nAttributes);
  attributes = Malloc_Struct(attributes);
  attributes->nAttributes = nAttributes;
  attributes->array = Malloc(nAttributes * sizeof (Attribute));
  for (a = 0; a < nAttributes; a++)
    attributes->array[a] = va_arg(args, Attribute);
  va_end(args);
  return attributes;
}

Boolean
Attributes_Match(Attributes attributes, Terminal wb)
{
  int a;
  Terminal_Properties properties;
  if (attributes == NULL) return TRUE;
  properties = wb->u.properties;
  for (a = 0; a < attributes->nAttributes; a++)
    if (!Attribute_Match(attributes->array[a], properties)) return FALSE;
  return TRUE;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/

