/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/feature.c
* Description:  Implements feature.h
* Author:       Brett Kessler
* Created:      Wed Apr 15 20:27:09 1992
* Modified:     Sun May  3 18:11:37 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "feature.h"
#include "Malloc.h"
#include "segment.h"
#include "sign.h"
#include <stdarg.h>
#include <stdlib.h>

Feature
Feature_Create(int nPlains, ...)
{
  va_list arg;
  int f;
  Feature feature;
  feature = Malloc_Struct(feature);
  feature->nPlains = nPlains;
  feature->plains = Malloc(nPlains * sizeof (PlainSignedFeature));
  va_start(arg, nPlains);
  for (f = 0; f < nPlains; f++) 
    feature->plains[f] = va_arg(arg, PlainSignedFeature);
  va_end(arg);
  return feature;
}

Boolean
Feature_Match(Feature feature, Segment segment, Sign_VarsVector vars)
{
  int p;
  for (p = 0; p < feature->nPlains; p++)
    if (PlainSignedFeature_Match(feature->plains[p], segment, vars))
      return TRUE;
  return FALSE;
}

Segment
Feature_Add(Feature feature, Segment segment, Sign_VarsVector variables)
{
  if (feature->nPlains != 1) {
    (void) printf("Don't know how to add a disjunction of features.\n");
    exit(1);
  }
  return PlainSignedFeature_Add(feature->plains[0], segment, variables);
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
