/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/indexedAVM.c
* Description:  Implements indexedAVM.h
* Author:       Brett Kessler
* Created:      Wed Apr 15 21:46:38 1992
* Modified:     Sun May  3 19:35:53 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "indexedAvm.h"
#include "Malloc.h"

IndexedAVM
IndexedAVM_Create(AVM avm, char indx)
{
  IndexedAVM i;
  i = Malloc_Struct(indexedAVM);
  i->avm = avm;
  i->index = indx;
  return i;
}

void
IndexedAVM_Match(IndexedAVM avm, Match_Facts facts)
{
  Segment origIndex;
  Terminal currentTerm;
  Segment currentSegment;
  origIndex = facts->in.indexes[(int) avm->index];
  currentTerm = facts->in.text->datum;
  currentSegment = currentTerm->u.segment;
  if ((currentTerm->type != Terminal_segmentType) ||
      (origIndex && origIndex != currentSegment)) {
    return;
  }
  facts->in.indexes[(int) avm->index] = currentSegment;
  AVM_Match(avm->avm, facts);
  if (facts->out.success) return;
  facts->in.indexes[(int) avm->index] = origIndex;
}

DList_Cons
IndexedAVM_InsertAfter(IndexedAVM avm,
		       Terminal_String string,
		       DList_Cons afterCons,
		       Match_IndexVector indexes,
		       Sign_VarsVector vars)
{
  return AVM_InsertAfter(avm->avm,
		  string,
		  afterCons,
		  vars,
		  indexes[(int) avm->index]);
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
