/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/rules.c
* Description:  Implements rules.h
* Author:       Brett Kessler
* Created:      Wed Apr 15 22:05:16 1992
* Modified:     Sun May  3 20:10:18 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "rules.h"
#include "Malloc.h"
#include <stdarg.h>
#include <stdio.h>

Rules
Rules_Create(int nRules, ...)
{
  Rules rules;
  va_list args;
  int r;
  va_start(args, nRules);
  rules = Malloc_Struct(rules);
  rules->nRules = nRules;
  rules->array = Malloc(nRules * sizeof (Rules));
  for (r = 0; r < nRules; r++)
    rules->array[r] = va_arg(args, Rule);
  va_end(args);
  return rules;
}

void
Rules_MeasureLongestName(Rules rules)
{
  int r;
  for (r = 0; r < rules->nRules; r++) {
    int len;
    len = Rule_NameLength(rules->array[r]);
    if (len > Rule_longestNameLen) {
      Rule_longestNameLen = len;
      Rule_longestName = Rule_Name(rules->array[r]);
    }
  }
}

void
Rules_Run(Rules rules, Terminal_String data, Item onsetPattern, Boolean latex)
{
  int r;
  for (r = 0; r < rules->nRules; r++)
    Rule_Run(rules->array[r], data, onsetPattern, latex);
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
