/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/segment.h
* Description:  A phonetic segment in the text string.
* Author:       Brett Kessler
* Created:      Thu Apr 16 07:54:02 1992
* Modified:     Sun May  3 20:45:07 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(SEGMENT_H)
#define SEGMENT_H

#include "header.h"

/*
 * Segment
 *
 * A segment is represented as a bit mask of its component features.
 */
typedef unsigned long
Segment;

#define Segment_SYLL TRUE

/*
 * Segment_Fact
 *
 * Gives the facts associated with a segment in the SEGMENTS file.  The
 * mask contains the same information as the list of feature names.
 */
typedef struct Segment_fact {
  char* ascii;
  char* latex;
  Segment mask;
}* Segment_Fact;

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
