/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/segments.c
* Description:  Implements segments.h
* Author:       Brett Kessler
* Created:      Thu Apr 16 07:56:42 1992
* Modified:     Sun May  3 20:45:06 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "segments.h"
#include "features.h"
#include "segment.h"
#include "../frag/segmentsC"
#include <stdlib.h>

Segment
Segments_SegmentFromID(int id)
{
  return Segments_Facts[id].mask;
}

static int
FindSegmentId(Segment segment)
{
  int id;
  for (id = 0; id < Segments_COUNT; id++)
    if (segment == Segments_Facts[id].mask) return id;
  return -1;
}

void
Segments_PrintSegment(Segment segment, FILE* file, Boolean latex)
{
  int id;
  id = FindSegmentId(segment);
  if (id == -1) (void) fprintf(file, "<%d>", (int) segment);
  else
    (void)
      fputs((latex) ? Segments_Facts[id].latex : Segments_Facts[id].ascii,
	    file);
}

Boolean
Segments_IsSyll(Segment segment)
{
  static unsigned long int mask = 0;
  if (!mask) mask = Features_GetSyllMask();
  return (segment & mask) ? TRUE : FALSE;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
