/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/segments.h
* Description:  The inventory of segments.
* Author:       Brett Kessler
* Created:      Thu Apr 16 07:51:33 1992
* Modified:     Sun May  3 20:45:06 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(SEGMENTS_H)
#define SEGMENTS_H

#include "../frag/segmentsH"
#include "list.h"
#include "resource.h"
#include "segment.h"
#include <stdio.h>

typedef List /* of Segment */ 
Segments;

/*
 * Segments_Facts
 *
 * The ASCII, LaTeX, and Segment feature bundle for each segment ID.
 */
struct Segment_fact
Segments_Facts[Segments_COUNT + 1];

/*
 * Segments_SegmentFromID
 * 
 * Given the numeric ID of a segment, return its feature bundle mask.
 */
extern Segment
Segments_SegmentFromID(int id);

/*
 * Segments_PrintSegment
 *
 * Display the segment on the file.  If the feature bundle is one of those
 * defined in SEGMENTS, the Ascii or LaTeX value will be displayed, depending
 * on the Boolean.  Otherwise, there will be printed in angled brackets a
 * number corresponding to the feature bundle.
 */
extern void
Segments_PrintSegment(Segment segment, FILE* file, Boolean latex);

/*
 * Segments_IsSyll
 *
 * Returns TRUE iff the segment is +syll.
 */
extern Boolean
Segments_IsSyll(Segment segment);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
