/*  -*- mode:     C -*- --------------------------------------------------
* File:         derive/sign.c
* Description:  Implements sign.h
* Author:       Brett Kessler
* Created:      Wed Apr 15 20:19:31 1992
* Modified:     Sun May  3 20:45:04 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "sign.h"
#include "header.h"
#include "Malloc.h"

Sign
Sign_CreateConstant(Sign_Direction direction)
{
  Sign s;
  s = Malloc_Struct(sign);
  s->type = Sign_constantType;
  s->u.direction = direction;
  return s;
}

Sign
Sign_CreateVariable(Sign_Variable var)
{
  Sign s;
  s = Malloc_Struct(sign);
  s->type = Sign_variableType;
  s->u.variable = var;
  return s;
}

void
Sign_InitVarsVector(Sign_VarsVector vector)
{
  int v;
  for (v = 0; v < Sign_NSIGNS; v++) 
    vector[v].type = Sign_unsetVarFactsType;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
