/*  -*- mode:     C -*- --------------------------------------------------
* File:         features/fvpair.h
* Description:  Feature value pair (in the FEATURES AVM)
* Author:       Brett Kessler
* Created:      Sat Mar 28 18:33:50 1992
* Modified:     Sat May  2 14:36:03 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(FVPAIR_H)
#define FVPAIR_H

#include "featName.h"
#include "valueType.h"

/*
 * FvPair
 *
 * A feature-value pair: the feature name, its numeric ID, and its value type.
 */
typedef struct fvPair {
  FeatName featName;
  int id;
  ValueType valueType;
}* FvPair;

/*
 * FvPair_Create
 *
 * Create a feature-value pair from a feature name and a value type.  The
 * numeric ID will be assign later, in avm.c.
 */
extern FvPair
FvPair_Create(FeatName featName, ValueType valueType);

/*
 * FvPair_Print
 *
 * Prints the pair in input format, as a debugging tool.
 */
extern void
FvPair_Print(FvPair fvPair, FILE* file, int indent);

#endif  /* end of code */

/*
******************************************************************************
* Revisions:
* RCS $Log: fvPair.h,v $
* RCS Revision 1.1  2000/02/29 11:06:23  bkessler
* RCS Backup
* RCS
******************************************************************************

******************************************************************************
*                                End of file
******************************************************************************
*/
