/*  -*- mode:     C -*- --------------------------------------------------
* File:         features/readFeaturesYacc.h
* Description:  Interface file for xduceFeatures parser.
* Author:       Brett Kessler
* Created:      Sat Mar 28 17:50:45 1992
* Modified:     Sat May  2 14:36:03 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(READFEATURESYACC_H)
#define READFEATURESYACC_H

#include <stdio.h>
extern char yytext[];


/*
 * ReadFeaturesYacc_Parse
 *
 * Reads the FEATURES specification on standard input, and transduces it to
 * three files which will be used as fragments in Lex and C files.
 */
extern void
ReadFeaturesYacc_Parse(FILE* phonesLexFile,
		       FILE* featureIncludeFile,
		       FILE* featureCFile);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
