/*  -*- mode:     C -*- --------------------------------------------------
* File:         features/valueType.c
* Description:  Implements valueType.h
* Author:       Brett Kessler
* Created:      Sat Mar 28 18:14:33 1992
* Modified:     Sat May  2 14:36:02 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "valueType.h"
#include "Malloc.h"
#include <stdio.h>

ValueType
ValueType_CreateBinary(void)
{
  ValueType vt;
  vt = Malloc_Struct(valueType);
  vt->type = ValueType_binary;
  vt->avm = NULL;
  return vt;
}

ValueType
ValueType_CreateAVM(AVM avm)
{
  ValueType vt;
  vt = Malloc_Struct(valueType);
  vt->type = ValueType_avm;
  vt->avm = avm;
  return vt;
}

/* If value is a sub-AVM, this goes recursive. */
void
ValueType_Print(ValueType vt, FILE* file, int indent)
{
  switch (vt->type) {
  case ValueType_binary: (void) fprintf(file, "binary"); break;
  case ValueType_avm: AVM_Print(vt->avm, file, indent); break;
  }
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
