/*  -*- mode:     C -*- --------------------------------------------------
* File:         features/xduceFeatures.c
* Description:  Main module for xduceFeatures: read FEATURES, gen source code.
* Author:       Brett Kessler
* Created:      Sat Mar 28 17:52:22 1992
* Modified:     Mon May  4 08:31:30 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "readFeaturesYacc.h"
#include <stdio.h>
#include <stdlib.h>

static FILE*
OpenFile(char* name)
{
  FILE* file;
  file = fopen(name, "w");
  if (file == NULL) {
    (void) fprintf(stderr, "Error: can't open or create file '%s'\n", name);
    exit(1);
  }
  return file;
}

/*
 * main
 *
 * Read the input file (../FEATURES) and produce Lex and C source code under
 * the names indicated.
 */
int
main(void)
{
  FILE* phonesLex;
  FILE* featureInclude;
  FILE* featureC;
  phonesLex = OpenFile("../frag/featuresLex");
  featureInclude = OpenFile("../frag/featuresH");
  featureC = OpenFile("../frag/featuresC");
  ReadFeaturesYacc_Parse(phonesLex,
			 featureInclude,
			 featureC);
  return 0;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
