/*  -*- mode: C -*- -----------------------------------------
 * File:           Resource.h
 * Decsription:    Resource where all elements are freed at once.
 * Author:         Brett Kessler
 * Created:        10-Jan-92
 * Language:       C
 **************************************************************
 */

#if !defined(RESOURCE_H)
#define RESOURCE_H

#define Resource_DEFAULT_OBJECTS_PER_BLOCK 100

typedef struct resourceBlock {
  void* objects;
  struct resourceBlock* next;
}* ResourceBlock;

typedef struct resource {
  ResourceBlock lastBlockInUse;
  unsigned int nextByte; /* counter, within lastBlockInUse */
  unsigned int charsPerObject;
  unsigned int charsPerBlock;
  ResourceBlock blocks;
}* Resource;

/*
 * Resource_Create
 */
extern Resource
Resource_Create(unsigned int charsPerObject, unsigned int objectsPerBlock);

/*
 * Resource_Get
 */
extern void*
Resource_Get(Resource resource);

/*
 * Resource_Free
 *
 * Frees all elements in resource.
 */
extern void
Resource_Free(Resource resource);

#endif
