/*  -*- mode: C -*- -----------------------------------------
 * File:           List.c
 * Decsription:    Singly linked list of pointers (FIFO queue).
 * Author:         Brett Kessler
 * Created:        10-Jan-92
 * Language:       C
 **************************************************************
 */

#include "list.h"
#include "resource.h"
#include <stdio.h>
#include <stdlib.h>

static Cons
Add(List* list, void* datum)
{
  Cons cons;
  if (*list == NULL) {
    *list = List_Create();
    if (*list == NULL) return NULL;
  }
  cons =
    ((*list)->consResource == NULL) ?
    Malloc(sizeof (struct cons))
    : Resource_Get((*list)->consResource);
  if (cons == NULL) return NULL;
  cons->datum = datum;
  cons->next = NULL;
  if ((*list)->tail == NULL) (*list)->head = cons;
  else ((*list)->tail)->next = cons;
  (*list)->tail = cons;
  (*list)->count++;
  return cons;
}

List
List_Add(List list, void* datum) {
  Cons cons;
  cons = Add(&list, datum);
  if (cons == NULL) return NULL;
  return list;
}

void
List_Init(List list)
{
  list->count = 0;
  list->head = NULL;
  list->tail = NULL;
  list->consResource = NULL;
}

List
List_Create()
{
  List list;
  list = Malloc(sizeof (struct list));
  if (list == NULL) return NULL;
  List_Init(list);
  return list;
}

Resource
List_CreateCons(unsigned int consPerBlock)
{
  if (consPerBlock <= 0) consPerBlock = List_DEFAULT_CONS_PER_BLOCK;
  return Resource_Create(sizeof (struct cons), consPerBlock);
}
