/*  -*- mode: C -*- -----------------------------------------
 * File:           Malloc.c
 * Decsription:    A malloc trained to die when out of memory.
 * Author:         Brett Kessler
 * Created:        10-Jan-92
 * Language:       C
 **************************************************************
 */

#include "Malloc.h"
#include <stdio.h>
#include <stdlib.h>

/*
 * Malloc
 *
 * mallocs a block of the indicated number of bytes.  If 0, returns NULL.
 * Client should deallocate via free(3).
 */
extern void*
Malloc(unsigned int nBytes) {
  void* mem;
  if (!nBytes) return NULL;
  mem = malloc(nBytes);
  if (mem == NULL) {
    (void) fprintf(stderr, "Malloc: could not allocate %u bytes.", nBytes);
    exit(1);
  }
  return mem;
}
