/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/attribute.h
* Description:  A lexical feature.
* Author:       Brett Kessler
* Created:      Sun Apr 26 20:30:05 1992
* Modified:     Sun May  3 15:14:07 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(ATTRIBUTE_H)
#define ATTRIBUTE_H

#include "sign.h"
#include <stdio.h>

/*
 * Attribute
 *
 * A lexical attribute.  Sign must be a constant, telling whether the
 * atribute is (or is required to be) present or not.  id is the numeric
 * identifier which xduceSegments assigned to the attribute.
 */
typedef struct attribute {
  Sign constant;
  int id;
}* Attribute;

/*
 * Attribute_Create
 *
 * Creates and returns an Attribute object.
 */
extern Attribute
Attribute_Create(Sign constant, int id);

/*
 * Attribute_Print
 *
 * Prints on the rules.c file the C code which will regenerate an
 * Attribute object in xduceRules.  This happens to be the same
 * as Attribute_Create above.
 */
extern void
Attribute_Print(Attribute attribute, FILE* file);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
