/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/avm.c
* Description:  Implements avm.h
* Author:       Brett Kessler
* Created:      Tue Apr 14 17:54:20 1992
* Modified:     Sun May  3 15:14:05 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "avm.h"
#include "feature.h"
#include "list.h"
#include "print.h"

AVM
AVM_Create(List features)
{
  AVM avm;
  avm = Malloc_Struct(avm);
  avm->features = (features == NULL) ? List_Create() : features;
  return avm;
}

/*
 * Note that the derive/ version of AVM_Create is different: instead of
 * taking a list, it takes a count plus an arbitrary number of features
 * as arguments.
 */
void
AVM_Print(AVM avm, FILE* file)
{
  Cons featureCons;
  Feature feature;
  int count = 0;
  Print_Indent(file);
  Print_level++;
  (void) fprintf(file, "AVM_Create(%d", avm->features->count);
  List_ForEach(avm->features, featureCons, feature) {
    (void) fprintf(file, ",\n");
    Print_Indent(file);
    (void) fprintf(file, "/* AVM feature #%d */\n", count);
    Feature_Print(feature, file);
    count++;
  }
  (void) fprintf(file, ")");
  Print_level--;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
