/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/indexedAVM.c
* Description:  Implements indexedAVM.h
* Author:       Brett Kessler
* Created:      Mon Apr 13 21:43:40 1992
* Modified:     Sun May  3 15:14:01 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "indexedAVM.h"
#include "Malloc.h"
#include "print.h"
#include <stdlib.h>

IndexedAVM
IndexedAVM_Create(AVM avm, char indx)
{
  IndexedAVM i;
  i = Malloc_Struct(indexedAVM);
  i->avm = avm;
  i->index = indx;
  return i;
}

/*
 * Instead of actually printing out the index letter, this prints out a
 * number from 0 to 25, so that arrays of indices can be handled more 
 * efficiently in the next programme.
 */
void
IndexedAVM_Print(IndexedAVM avm, FILE* file)
{
  Print_Indent(file);
  Print_level++;
  (void) fputs("IndexedAVM_Create(\n", file);
  AVM_Print(avm->avm, file);
  (void) fprintf(file, ",\n");
  Print_Indent(file);
  (void) fprintf(file, "/* Indexed AVM index: */ '\\%.3o')", avm->index - 'a');
  Print_level--;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
