/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/indexedAVM.h
* Description:  A feature-bundle AVM with an index.
* Author:       Brett Kessler
* Created:      Thu Apr  9 08:58:40 1992
* Modified:     Sun May  3 15:14:02 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(INDEXEDAVM_H)
#define INDEXEDAVM_H

#include "avm.h"
#include <stdio.h>
/*
 * IndexedAVM
 *
 * An AVM that has an identity index (introduced in the RULES file by
 * underscores, but here only the subscripted letter is saved).
 */
typedef struct indexedAVM {
  AVM avm;
  char index;
}* IndexedAVM;

/*
 * IndexedAVM_Create
 *
 * Creates an IndexedAVM from an AVM and an index letter.
 */
extern IndexedAVM
IndexedAVM_Create(AVM avm, char indx);

/*
 * IndexedAVM_Print
 *
 * Prints on the stream (frag/rules.c) the code necessary to reconstruct this
 * object in another programme ("derive").
 */
extern void
IndexedAVM_Print(IndexedAVM avm, FILE* file);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
