/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/plainSignedFeature.c
* Description:  Implements plainSignedFeature.h
* Author:       Brett Kessler
* Created:      Mon Apr 13 21:39:58 1992 (Brett Kessler)
* Modified:     Sun May  3 15:13:58 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "plainSignedFeature.h"
#include "Malloc.h"
#include "print.h"
#include <stdlib.h>

PlainSignedFeature
PlainSignedFeature_Create(Sign sign, int featureNumber)
{
  PlainSignedFeature psf;
  psf = Malloc_Struct(plainSignedFeature);
  psf->sign = sign;
  psf->featureNumber = featureNumber;
  return psf;
}

void
PlainSignedFeature_Print(PlainSignedFeature feat, FILE* file)
{
  Print_Indent(file);
  Print_level++;
  (void) fputs("PlainSignedFeature_Create(\n", file);
  Sign_Print(feat->sign, file);
  (void) fprintf(file, ", %d)", feat->featureNumber);
  Print_level--;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
