/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/print.h
* Description:  Globally manages indentation levels for rules.c
* Author:       Brett Kessler
* Created:      Wed Apr 15 08:51:12 1992
* Modified:     Sun May  3 16:08:28 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(PRINT_H)
#define PRINT_H

#include <stdio.h>

/*
 * Print_level
 *
 * A global variable that the Print functions in the various modules use
 * to keep track of the current level of indentation in the rules.c file.
 * An object with embedded structure will increment this variable before
 * calling the print function for its children, and decrement it when
 * it returns.
 */
extern int
Print_level;

/*
 * Print_Indent
 *
 * Prints on the stream the number of spaces corrsponding to the current
 * value of Print_level.
 */
extern void
Print_Indent(FILE* file);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
