/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/rule.c
* Description:  Implements rule.h
* Author:       Brett Kessler
* Created:      Mon Apr 13 21:29:04 1992
* Modified:     Sun May  3 15:13:54 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "rule.h"
#include "Malloc.h"
#include "print.h"
#include <stdlib.h>

Rule
Rule_CreateOrdinary(char* name,
		    Item original,
		    Item change,
		    Item environment)
{
  Rule r;
  r = Malloc_Struct(rule);
  r->type = Rule_ordinaryType;
  r->name = name;
  r->original = original;
  r->change = change;
  r->environment = environment;
   return r;
}

Rule
Rule_CreateSpecial(Rule_Type specialRuleNumber)
{
  Rule r;
  r = Malloc_Struct(rule);
  r->type = specialRuleNumber;
  return r;
}

void
Rule_Print(Rule rule, FILE* file)
{
  Print_Indent(file);
  switch (rule->type) {
  case Rule_ordinaryType:
    (void) fprintf(file, "Rule_CreateOrdinary(%s,\n", rule->name);
    Print_level++;
    Print_Indent(file); (void) fputs("/* Rule original: */\n", file);
    Item_Print((rule->environment == NULL) ? 
	         Item_NoEnvironment() : rule->environment,
	       file,
	       rule->original);
    (void) fputs(",\n", file);
    Print_Indent(file); (void) fputs("/* Rule change: */\n", file);
    Item_Print(rule->change, file, NULL);
    (void) fputs(")", file);
    Print_level--;
    break;
  case Rule_maximizeOnsets:
    (void) fputs("Rule_CreateSpecial(Rule_maximizeOnsets)", file);
    break;
  }
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
