/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/ruleSystem.c
* Description:  Implements ruseSystem.h
* Author:       Brett Kessler
* Created:      Mon Apr 13 21:26:23 1992
* Modified:     Sun May  3 15:28:27 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "ruleSystem.h"
#include "factor.h"
#include "list.h"
#include "Malloc.h"
#include "print.h"
#include "rule.h"
#include <stdlib.h>

RuleSystem
RuleSystem_Create(Item onsets, Rules rules)
{
  RuleSystem r;
  r = Malloc_Struct(ruleSystem);
  r->onsets = onsets;
  r->rules = rules;
  return r;
}

void
RuleSystem_Print(RuleSystem systm, FILE* file)
{
  (void) fputs("RuleSystem_Create(\n", file);
  Print_level = 1;
  (void) fputs(" /* onsets */\n", file);
  Item_PrintOnsets(systm->onsets, file);
  (void) fputs(",\n /* RuleSystem rules */\n", file);
  Rules_Print(systm->rules, file);
  (void) fputs(")\n", file);
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
