/*  -*- mode:     C -*- --------------------------------------------------
* File:         ruleSystem.h
* Description:  The entire structure of the RULES file.
* Author:       Brett Kessler
* Created:      Thu Apr  9 09:08:46 1992
* Modified:     Sun May  3 15:29:51 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(RULESYSTEM_H)
#define RULESYSTEM_H

#include "item.h"
#include "rules.h"
#include <stdio.h>

/*
 * RuleSystem
 *
 * A data structure for the ONSETS and RULES of a RULES file.
 */
typedef struct ruleSystem {
  Item onsets;
  Rules rules;
}* RuleSystem;

/*
 * RuleSystem_Create
 * 
 * Creates a RuleSystem from its two components.
 */
extern RuleSystem
RuleSystem_Create(Item onsets, Rules rules);

/*
 * RuleSystem_Print
 *
 * Prints on the stream (frag/rules.c) the C code for rebuilding the
 * RuleSystem structure in another programme ("derive").
 */
extern void
RuleSystem_Print(RuleSystem systm, FILE* file);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
