/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/rules.c
* Description:  Implements rules.h
* Author:       Brett Kessler
* Created:      Tue Apr 14 18:27:43 1992
* Modified:     Sun May  3 15:28:26 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "rules.h"
#include "list.h"
#include "Malloc.h"
#include "print.h"
#include "rule.h"
#include <stdio.h>

Rules
Rules_Create(Rule firstRule)
{
  Rules r;
  r = Malloc_Struct(rules);
  r->list = List_Create();
  (void) List_Add(r->list, firstRule);
  return r;
}

Rules
Rules_Add(Rules rules, Rule new)
{
  (void) List_Add(rules->list, new);
  return rules;
}

/* 
 * Note that in the next programme, a Rules is created in one swoop, with
 * a procedure that takes an arbitrarily long list of Rule's.
 */
void
Rules_Print(Rules rules, FILE* file)
{
  Cons ruleCons;
  Rule rule;
  int count = 0;
  Print_Indent(file);
  (void) fprintf(file, "Rules_Create(%d", rules->list->count);
  Print_level++;
  List_ForEach(rules->list, ruleCons, rule) {
    (void) fprintf(file, ",\n");
    Print_Indent(file);
    (void) fprintf(file, "/* Rules #%d */\n", count);
    Print_Indent(file);
    Rule_Print(rule, file);
    count++;
  }
  (void) fprintf(file, ")");
  Print_level--;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
