/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/rules.h
* Description:  A structure for the sequence of rules in RULES.
* Author:       Brett Kessler
* Created:      Tue Apr 14 17:05:08 1992
* Modified:     Sun May  3 15:29:51 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(RULES_H)
#define RULES_H

#include "list.h"
#include "rule.h"
#include <stdio.h>

/*
 * Rules
 *
 * Rules is the sequence of rules listed in the RULES section of the RULES
 * file.  Order is significant.
 */
typedef struct rules {
  List /* of Rule */ list;
}* Rules;

/*
 * Rules_Create
 *
 * Creates a Rules object and initializes it with its first rule.
 */
extern Rules
Rules_Create(Rule firstRule);

/*
 * Rules_Add
 *
 * Adds a new Rule to the end of the Rules object's list, and returns the
 * same Rules object.
 */
extern Rules
Rules_Add(Rules rules, Rule new);

/*
 * Rules_Print
 * 
 * Prints on the stream (frag/rules.c) the C code for rebuilding the Rules
 * object in another programme ("derive").
 */
extern void
Rules_Print(Rules rules, FILE* file);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
