/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/sign.c
* Description:  Implements sign .h
* Author:       Brett Kessler
* Created:      Mon Apr 13 21:41:47 1992 (Brett Kessler)
* Modified:     Sun May  3 15:28:24 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "sign.h"
#include "Malloc.h"
#include "print.h"
#include <stdio.h>
#include <stdlib.h>

Sign
Sign_CreateConstant(Sign_Direction direction)
{
  Sign sign;
  sign = Malloc_Struct(sign);
  sign->type = Sign_constantType;
  sign->u.direction = direction;
  return sign;
}

Sign
Sign_CreateVariable(Sign_Variable sign)
{
  Sign s;
  s = Malloc_Struct(sign);
  s->type = Sign_variableType;
  s->u.variable = sign;
  return s;
}

static void
Sign_PrintDirection(Sign_Direction d, FILE* file)
{
  switch (d) {
  case Sign_PLUS: fputs("Sign_PLUS", file); break;
  case Sign_MINUS: fputs("Sign_MINUS", file); break;
  }
}

static void
Sign_PrintVariable(Sign_Variable v, FILE* file)
{
  switch (v) {
  case Sign_ALPHA: fputs("Sign_ALPHA", file); break;
  case Sign_BETA: fputs("Sign_BETA", file); break;
  case Sign_GAMMA: fputs("Sign_GAMMA", file); break;
  case Sign_DELTA: fputs("Sign_DELTA", file); break;
  }
}

void
Sign_Print(Sign sign, FILE* file)
{
  Print_Indent(file);
  switch (sign->type) {
  case Sign_constantType: 
    (void) fprintf(file, "Sign_CreateConstant(");
    Sign_PrintDirection(sign->u.direction, file);
    (void) fprintf(file, ")");
    break;
  case Sign_variableType:
    (void) fprintf(file, "Sign_CreateVariable(");
    Sign_PrintVariable(sign->u.variable, file);
    (void) fprintf(file, ")");
    break;
  }
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
