/*  -*- mode:     C -*- --------------------------------------------------
* File:         rules/xduceRules.c
* Description:  Main module for xduceRules
* Author:       Brett Kessler
* Created:      Wed Apr  1 08:39:26 1992
* Modified:     Mon May  4 08:31:28 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#include "readRulesYacc.h"
#include "ruleSystem.h"
#include <stdio.h>

static FILE*
OpenFile(char* name)
{
  FILE* f;
  f = fopen(name, "w");
  if (f == NULL) {
    (void) fprintf(stderr, "Can't open '%s' for writing.\n", name);
    exit(1);
  }
  return f;
}

/*
 * Reads RULES file from standard input, then writes them as C code on
 * rules.c in frag.
 */
int
main(void)
{
  RuleSystem ruleSystem;
  ruleSystem = ReadRulesYacc_Parse();
  RuleSystem_Print(ruleSystem, OpenFile("../frag/rules.c"));
  return 0;
}

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
