/*  -*- mode:     C -*- --------------------------------------------------
* File:         segments/readSegmentsYacc.h
* Description:  Interface file to the SEGMENTS transducer.
* Author:       Brett Kessler
* Created:      Sun Mar 29 17:51:51 1992
* Modified:     Mon May  4 08:27:37 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(READSEGMENTSYACC_H)
#define READSEGMENTSYACC_H

#include <stdio.h>

/*
 * ReadSegmentsYacc_Parse
 *
 * Reads the SEGMENTS specification from stdin, parses it, creating six
 * files (in frag/) which constitute source code fragments for later
 * programmes (xduceRules and derive).
 */
extern void
ReadSegmentsYacc_Parse(FILE* segmentsLex, 
		       FILE* segmentsH,
		       FILE* segmentsC,
		       FILE* attributesLex,
		       FILE* attributesH,
		       FILE* attributesC);

#endif  /* end of code */

/*
******************************************************************************
*                                End of file
******************************************************************************
*/
