/*  -*- mode:     C -*- --------------------------------------------------
* File:         segments/xduceSegments.c
* Description:  Main module for xduceSegments.
* Author:       Brett Kessler
* Created:      Sun Mar 29 17:53:35 1992
* Modified:     Tue Jun  9 15:43:02 1992 (Brett Kessler)
* Language:     C
******************************************************************************
*/

#if !defined(XDUCESEGMENTS_H)
#define XDUCESEGMENTS_H

#include "readSegmentsYacc.h"
#include <stdio.h>
#include <stdlib.h>

static FILE*
OpenFile(char* name)
{
  FILE* file;
  file = fopen(name, "w");
  if (file == NULL) {
    (void) fprintf(stderr, "Couldn't open file '%s' for writing.\n", name);
    exit(1);
  }
  return file;
}

int
main(void)
{
  FILE* segmentsLex;
  FILE* segmentsH;
  FILE* segmentsC;
  FILE* attributesLex;
  FILE* attributesH;
  FILE* attributesC;
  segmentsLex = OpenFile("../frag/segmentsLex");
  segmentsH = OpenFile("../frag/segmentsH");
  segmentsC = OpenFile("../frag/segmentsC");
  attributesLex = OpenFile("../frag/attributesLex");
  attributesH = OpenFile("../frag/attributesH");
  attributesC = OpenFile("../frag/attributesC");
  ReadSegmentsYacc_Parse(segmentsLex, 
			 segmentsH,
			 segmentsC,
			 attributesLex,
			 attributesH,
			 attributesC);
  return 0;
}

#endif  /* end of code */

/*
*********************************************************************

******************************************************************************
*                                End of file
******************************************************************************
*/
